<?php 
// ArwShop Market v3.3.18 Copyright (c) Igor Anikeev ( https://webnav.link/ ) 2006 - 2024.
?><?php
error_reporting(E_ALL & ~E_NOTICE);
@ini_set('display_errors', 'On');
header("Content-type: text/html; charset=utf-8");
 if(function_exists('set_time_limit')){
 @set_time_limit(120);
 }

define('SYS_LOADER', 1);
define('INSTALL_DIR', '.');
define('SCRIPT_DIR', '..');
define('SCRIPTCHF_DIR', SCRIPT_DIR);
define('INC_DIR', SCRIPT_DIR."/inc");
define('DEBUG_MODE', 0);


@ini_set('default_charset', 'utf-8');

$chk_folders = array(
 'img',
 'img/small',
 'img/big',
 'pubfiles',
 'ecache',
 'adm/dump'
);

 if(file_exists(INC_DIR."/custom.php")){
 require_once(INC_DIR."/custom.php");
 }
 else{
 die(inst_fatal_err("Can't require ".INC_DIR."/custom.php"));
 }

$custom=new custom;
$custom->check_mb();
$custom->check_magic_quotes_gpc();
$custom->check_timezone();
$custom->get_lang('install');

if(file_exists(SCRIPTCHF_DIR."/fs.php")){die($lang['delete_config']);}

?><!DOCTYPE html><html><head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="pragma" content="no-cache"><title><?php echo $lang['installation']; ?> ArwShop Market</title>
<meta name="Author" content="Igor Anikeev">
<meta name="Copyright" content="Igor Anikeev, webnav.link">
<meta name="ProductName" content="ArwShop Market">
<link href="../adm/admin2.css" rel="stylesheet" type="text/css">
<style type="text/css">
table td{color:#133f66;}
</style>
</head><body topmargin="0" leftmargin="0" bottommargin="0" rightmargin="0"  style="height:100%;">
<table width="100%" height="100%" border="0" bgcolor="#ffffff">
 <tr class="ahdr" height="40">
  <td>
   <table width="100%" cellspacing="0" cellpadding="0" style="border-bottom: 1px inset #ffffff;">
    <tr>
     <td><a href="http://webnav.link/" target="_blank"><img src="arwshop.gif" alt="ArwShop Market" border="0"></a></td>
     <td>
<table>
 <tr>
  <td><b style="font-size:18px;"><img src="install.gif" style="vertical-align:middle;margin-right:12px;"><?php echo $lang['welcome_to_install']; ?></b></td>
 </tr>
</table>
     </td>
    </tr>
   </table>
  </td>
 </tr>
 <tr>
  <td align="center" valign="top">

<table width="80%">
 <tr>
  <td>

<?php
 if(! isset($_POST['step'])){
 $_POST['step'] = '';
 }

$err_msg = '';

 if(file_exists(SCRIPT_DIR."/license.txt")){

  switch($_POST['step']){

  case '1':

    if(! empty($_POST['agree_license'])){

     if(file_exists(INSTALL_DIR."/step2.php")){
     include(INSTALL_DIR."/step2.php");
     }
     else{
     die(inst_fatal_err("Can't include ".INSTALL_DIR."/step2.php"));
     }

    }
    else{
    $err_msg="<font class=\"red\">$lang[not_license_agree]</font><br>";

     if(file_exists(INSTALL_DIR."/step1.php")){
     include(INSTALL_DIR."/step1.php");
     }
     else{
     die(inst_fatal_err("Can't include ".INSTALL_DIR."/step1.php"));
     }

    }

  break;



  case '2':

  $check_err=check_folders_perms();
 
   if($check_err['err_code']!=1){
  
   $err_msg=$check_err['result'];
   
    if(file_exists(INSTALL_DIR."/step2.php")){
    include(INSTALL_DIR."/step2.php");
    }
    else{
    die(inst_fatal_err("Can't include ".INSTALL_DIR."/step2.php"));
    }

   break;
   }

   if(file_exists(INSTALL_DIR."/step3.php")){
   include(INSTALL_DIR."/step3.php");
   }
   else{
   die(inst_fatal_err("Can't include ".INSTALL_DIR."/step3.php"));
   }

  break;




  case '3':

  $check_err = check_admin_data();

   if($check_err !== '1'){
   $err_msg=$check_err;

    if(file_exists(INSTALL_DIR."/step3.php")){
    include(INSTALL_DIR."/step3.php");
    }
    else{
    die(inst_fatal_err("Can't include ".INSTALL_DIR."/step3.php"));
    }

   break;
   }

   if(file_exists(INSTALL_DIR."/step4.php")){
   include(INSTALL_DIR."/step4.php");
   }
   else{
   die(inst_fatal_err("Can't include ".INSTALL_DIR."/step4.php"));
   }

  break;


  default:

    if(file_exists(INSTALL_DIR."/step1.php")){
    include(INSTALL_DIR."/step1.php");
    }
    else{
    die(inst_fatal_err("Can't include ".INSTALL_DIR."/step1.php"));
    }

  }

 }
 else{
 die(inst_fatal_err("Can't open file ".SCRIPT_DIR."/license.txt"));
 }
?>

</td>
 </tr>
</table>

  </td>
 </tr>
 <tr class="aftr" height="30">
  <td>
<table width="100%" cellspacing="0" cellpadding="0" style="border-top: 1px outset #ffffff;border-bottom: 1px inset #ffffff;"><tr><td align="center"><br>
<font style="font-size:12px">Copyright &copy; <a href="http://webnav.link/" target="_blank">WebNav.link</a></font><br><br></td></tr></table>
  </td>
 </tr>
</table>
</body></html>
<?php

function inst_execSqlfile($fname, $prefix){
if(! file_exists($fname)){die(inst_fatal_err("Can't open file $fname"));}
global $db;


$fh_input=fopen($fname, "r") or die("Can't open file $fname");
$line=0;
 while(! feof($fh_input)){
 $str=fgets($fh_input, 67000);


 $line++;
 if(substr($str, 0, 1) != "\x0D" && substr($str, 0, 1) != "\x0A"){$str=trim($str);}

  if($str && substr($str, 0, 2) !== '--' && substr($str, 0, 1) !== '#'){
  $str=str_replace('`arwm_', "`$prefix", $str);
  $str=str_replace("'arwm_", "'$prefix", $str);
  $str=str_replace('"arwm_', "\"$prefix", $str);
  $str=str_replace(' arwm_', " $prefix", $str);
  $str=str_replace('"', '\\"', $str);
  $query.=$str;

    if(substr($query, strlen($query)-1) == ';'){

      if($query){
      $res = $db->query($query) or die($db->error()." (Line: $line at SQL file)<br>");
      if(! $res){return false;}
      }

    $query='';
    }

  }
  else{
  $query='';
  }

 }
fclose($fh_input);

return true;
}

function get_sys_url(){
$domain = domain_from_url($_SERVER['HTTP_HOST'], false);
$url = "http://$domain$_SERVER[REQUEST_URI]";
$pos=strrpos($url, '/');
 if($pos){
 return substr($url, 0, $pos-7);
 }
 else{
 return '';
 }
}

function write_connection_info($data){
if(file_exists(SCRIPTCHF_DIR."/fs.php")){return 0;}
$fh1=@fopen(SCRIPTCHF_DIR."/fs.php", 'wb');
@fputs($fh1,$data);
return @fclose($fh1);
}


function set_db_data(){
global $db, $admin, $admin_lib;
$tbl=DB_PREFIX.'admin';
$db->query("INSERT INTO $tbl (adminid, name, password, status) VALUES(NULL, '$admin[name]', '$admin[password]', 'main_admin')") or die($db->error());
}


function check_admin_data(){
global $custom, $lang, $admin;
$err = '';
$admin = array();
$_POST['sql_db_prefix'] = strtolower(trim($_POST['sql_db_prefix']));
$prefix = $_POST['sql_db_prefix'];

 if(! $prefix){
 $err .= "$lang[no_db_prefix]<br>";
 }
 else{
  if(! preg_match('/^[a-z]{1,1}[a-z0-9\_]{0,}$/', $prefix)){
  $err .= "$lang[invalid_db_prefix]<br>";
  }
 }

 if(strlen($prefix) > 20){
 $err .= "$lang[long_db_prefix]<br>";
 }

$admin['name'] = $custom->del_notalphanum(trim($_POST['admin_login']));
if($admin['name'] !== $_POST['admin_login']){$err.="$lang[invalid_name]<br>";}
if(mb_strlen($admin['name'])<3){$err.="$lang[short_name]<br>";}
if($admin['name'] === 'demo'){$err.="$lang[no_demo]<br>";}

if($admin['name']){$admin['name']=md5($admin['name'] . 'Sys Administrator Login');}

$new_admin_password = $_POST['admin_password'];
$new_admin_password = $custom->del_notalphanum(trim($new_admin_password));
if($new_admin_password !== $_POST['admin_password']){$err.="$lang[invalid_pass]<br>";}
if(mb_strlen($new_admin_password)<6){$err.="$lang[short_pass]<br>";}

$admin['password'] = md5($new_admin_password . 'Sys Administrator Password');

$_POST['email'] = trim($_POST['email']);
$admin['email'] = $_POST['email'];
require_once(INC_DIR."/mailer.php");
$mailer = new mailer;
 if(! $mailer->valid_email($admin['email'])){
 $err .= "$lang[invalid_email]<br>";
 }

 if($err){
 return "<font class=\"red\">$err</font><br>";
 }

return '1';
}


function auto_email(){
$domain = domain_from_url($_SERVER['HTTP_HOST'], true);
 if(strstr(' '.$domain, 'xn--') || $domain == 'localhost'){
 $domain = 'example.com';
 }
return 'example@' . $domain;
}


function domain_from_url($url, $delete_www){
$domain = strtolower(trim($url));
$domain = str_replace("\\", '/', $domain);
$pos = strpos($domain, '://');
 if($pos !== false){
 $domain = substr($domain, $pos + 3);
 }
$pos = strpos($domain, '/');
 if($pos !== false){
 $domain = substr($domain, 0, $pos);
 }
 if(substr($domain, strlen($domain) - 1) === '.'){
 $domain = substr($domain, 0, strlen($domain) - 1);
 }
 if($delete_www && substr($domain, 0, 4) === 'www.'){
  if(substr_count($domain, '.') > 1){
  $domain = substr($domain, 4);
  }
 }
return $domain;
}


function delete_tables($prefix){
global $db;
$res=$db->query("SHOW TABLES FROM `$db->dbname`") or die($db->error());
if(! $res){return false;}
$dtables='';

 while($row=$db->fetch_row($res)){
  if(substr($row[0], 0, strlen($prefix)) == $prefix){
   if(! empty($dtables)){
   $dtables .= ', ';
   }
  $dtables .= $row[0];
  }
 }

 if(! empty($dtables)){
 $res=@$db->query("DROP TABLE $dtables") or die($db->error());
 if(! $res){return false;}
 }

return true;
}


function tables_quantity($dbname){
global $db;
$res=$db->query("SHOW TABLES FROM `$dbname`") or die($db->error());
if(! $res){return -1;}
return $db->num_rows($res);
}


function sgindt(){
global $custom;
return strtoupper($custom->text_to_hex(base64_encode(time())));
}


function inst_fatal_err($msg){
echo "<p style=\"color:#ff0000;\">$msg</p>";
}


function check_folders_perms(){
global $chk_folders, $lang;
$res='';
$def_class='ttr';
$all_valid = true;
 foreach($chk_folders as $dir){
 if($def_class=='str'){$def_class='ttr';}else{$def_class='str';}
 $valid = true;
 $msg = '';
 $wr = validate_dir_perms(SCRIPTCHF_DIR."/$dir");
  if(! $wr['writable']){
  $valid = false;
  $msg .= $lang['no_writable'].'<br>';
  }
  if(! $wr['readable']){
  $valid = false;
  $msg .= $lang['no_readable'].'<br>';
  }
  if($valid){
  $img='ok.gif';
  $msg = $lang['ok'];
  }
  else{
  $img='warning.gif';
  $all_valid = false;
  }
 $res.=<<<HTMLDATA
<tr class="$def_class"><td>$dir</td><td><img src="$img"></td><td align="center">$msg</td></tr>
HTMLDATA;
 }
return array('err_code' => $all_valid, 'result' => $res);
}


function validate_dir_perms($dir){
$writable=@iput_to_file("$dir/test.tmp", '1');
 if($writable){
 $readable=intval(@file_get_contents("$dir/test.tmp"));
 @unlink("$dir/test.tmp");
 }
 else{
 $readable=is_readable($dir);
 }
return array('writable'=>$writable,'readable'=>$readable);
}


function iput_to_file($file,$data){
$fh=@fopen($file,'wb');
if(! $fh){return false;}
@flock($fh,2);
@fputs($fh,$data);
@flock($fh,3);
return @fclose($fh);
}

?>